import 'package:dio/dio.dart';
import 'package:parse_sdk_dart/src/parse/parse_constants.dart';
import 'package:parse_sdk_dart/src/parse/parse_server_configuration.dart';

class ParseHttpClient {
  ParseServerConfiguration configuration = ParseServerConfiguration();
  static Dio _client;

  Dio getClient() {
    if (_client == null) {
      Map<String, String> headers = Map();
      headers.putIfAbsent(
          ParseConstants.USER_AGENT_KEY, () => ParseConstants.USER_AGENT_VALUE);
      headers.putIfAbsent(ParseConstants.CONTENT_TYPE_KEY,
          () => ParseConstants.CONTENT_TYPE_VALUE);
      if (configuration != null) {
        headers.putIfAbsent(ParseConstants.APPLICATION_ID_KEY,
            () => configuration.applicationId);
        if (configuration.masterKey != null) {
          headers.putIfAbsent(
              ParseConstants.MASTER_KEY, () => configuration.masterKey);
        }
      }

      Options options = new Options(
          baseUrl: configuration != null ? configuration.serverUrl : '',
          connectTimeout: ParseConstants.CONNECT_TIMEOUT,
          receiveTimeout: ParseConstants.RECEIVE_TIMEOUT,
          headers: headers);

      _client = Dio(options);
    }
    return _client;
  }
}
