class ParseServerConfiguration {
  static ParseServerConfiguration _instance;

  static ParseServerConfiguration get instance => _instance;

  static void init(serverUrl, applicationId,
          {liveQueryUrl, masterKey, sessionId}) =>
      _instance ??= ParseServerConfiguration._init(serverUrl, applicationId,
          liveQueryURL: liveQueryUrl,
          masterKey: masterKey,
          sessionId: sessionId);

  String applicationId;
  String serverUrl;
  String liveQueryURL;
  String masterKey;
  String sessionId;

  ParseServerConfiguration._init(this.serverUrl, this.applicationId,
      {this.liveQueryURL, this.masterKey, this.sessionId});

  factory ParseServerConfiguration() => _instance;

  void setSessionId(String sessionId) {
    this.sessionId = sessionId;
  }

  @override
  String toString() => "$applicationId $masterKey";
}
